/*
MySQL Backup
Source Host:           localhost
Source Server Version: 4.1.5-gamma-nt
Source Database:       multiconta
Date:                  2004-10-16 10:11:22
*/

use multiconta;
SET FOREIGN_KEY_CHECKS=0;
#----------------------------
# Table structure for ciudad
#----------------------------
CREATE TABLE `ciudad` (
  `id_ciudad` int(11) NOT NULL auto_increment,
  `id_region` int(11) NOT NULL default '0',
  `nombre` varchar(50) NOT NULL default '',
  `codigo_area` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_ciudad`),
  KEY `id_region` (`id_region`),
  CONSTRAINT `ciudad_ibfk_1` FOREIGN KEY (`id_region`) REFERENCES `region` (`id_region`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
#----------------------------
# Records for table ciudad
#----------------------------


insert  into ciudad values 
(1, 2, 'Antofagasta', 55), 
(2, 13, 'Santiago', 2), 
(3, 1, 'Iquique', 57), 
(4, 13, 'SAN CARLOS', 42);
#----------------------------
# Table structure for cliente_proveedor
#----------------------------
CREATE TABLE `cliente_proveedor` (
  `id_cliente_proveedor` int(11) NOT NULL auto_increment,
  `id_empresa` int(11) NOT NULL default '0',
  `id_comuna` int(11) NOT NULL default '0',
  `id_ciudad` int(11) NOT NULL default '0',
  `cliente_proveedor` int(11) NOT NULL default '0',
  `rut` varchar(10) NOT NULL default '',
  `nombre` varchar(255) NOT NULL default '',
  `razon_social` varchar(255) NOT NULL default '',
  `giro` varchar(255) NOT NULL default '',
  `tipo` varchar(255) NOT NULL default '',
  `direccion` varchar(255) NOT NULL default '',
  `telefono` int(11) NOT NULL default '0',
  `fax` int(11) NOT NULL default '0',
  `website` varchar(255) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `fecha_ingreso` varchar(14) NOT NULL default '',
  `estado` varchar(50) NOT NULL default '',
  `observacion` text NOT NULL,
  `extra1` varchar(255) NOT NULL default '',
  `extra2` varchar(255) NOT NULL default '',
  `extra3` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id_cliente_proveedor`),
  KEY `id_empresa` (`id_empresa`),
  CONSTRAINT `cliente_proveedor_ibfk_1` FOREIGN KEY (`id_empresa`) REFERENCES `empresa` (`id_empresa`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
#----------------------------
# Records for table cliente_proveedor
#----------------------------


insert  into cliente_proveedor values 
(2, 1, 2, 2, 2, '96.976.500', 'LIT CARGO S.A.', 'LIT CARGO S.A.', 'TRANSPORTE', '', 'SANTA CATALINA DE CHENA 1000', 5206600, 0, 'WWW.LIT.CL', '', '', '', '', '', '', ''), 
(3, 1, 1, 1, 2, '10.689.161', 'NELSON SANCHEZ SALAZAR', 'NELSON SANCHEZ SALAZAR', 'ALMACEN', '', 'IQUIQUE 4772 LOCAL 22-23', 251667, 0, '', '', '20040930', '', '', '', '', ''), 
(4, 1, 1, 1, 2, '93.473.000', 'COCACOLA POLAR', 'EMBOTELLADORA COCACOLA POLAR', 'EMBOTELLADORA', '', 'AVDA. PEDRO AGUIRRE CERDA 7986', 630630, 0, '', '', '20040102', '', '', '', '', ''), 
(5, 1, 2, 2, 2, '96.557.910', 'ALIMENTOS Y FRUTOS S.A.', 'ALIMENTOS Y FRUTOS S.A.', 'AGROINDUSTRIAL', '', 'LO ECHEVERS 250 QUILICURA SANTIAGO', 367800, 7390101, 'WWW.ALIFRUT.CL', '', '20040930', '', '', '', '', ''), 
(6, 1, 1, 1, 2, '91.004.000', 'PRODUCTOS FERNANDEZ S.A.', 'PRODUCTOS FERNANDEZ S.A.', 'INDUSTRIA ALIMENTICIA', '', 'BALMACEDA 2516', 412165, 412480, '', '', '', '', '', '', '', ''), 
(7, 1, 1, 1, 2, '5.277.042-', 'FRIO JB', 'JOSE ABEL BREVIS GALVARINO', 'SERVICIO TECNICO', '', 'ANTONIO RENDIC 5538', 475958, 234331, '', 'FRIOJB@LATINMAIL.COM', '', '', '', '', '', ''), 
(8, 1, 2, 2, 2, '85.714.200', 'COMERCIAL PANAMERICANA S.A.', 'COMERCIAL PANAMERICANA S.A.', 'DISTRIBUIDORA DE PRODUCTOS AGROINDUSTRIALES', '', 'LUIS PASTEUR 6105', 4269797, 4269769, '', '', '20040102', '', '', '', '', ''), 
(9, 1, 1, 1, 2, '88.989.400', 'DIPRODAL LTDA.', 'MAURICE LACLABERE E HIJO LTDA.', 'DISTRIBUIDORA', '', 'BAQUEDANO 299', 268669, 287527, '', 'MAURICELACLABERE@TIE.CL', '20040102', '', '', '', '', ''), 
(10, 2, 0, 1, 2, '', 'Proveedor 1', 'Proveedor que trae weaitas pa comer', '', '', '', 0, 0, '', '', '20040930', '', '', '', '', ''), 
(11, 1, 2, 2, 2, '78.003.240', 'FRISAC S.A.', 'FRISAC S.A.', 'PRODUCTOS AGRICOLAS CONGELADOS', '', 'AVDA. RICARDO LYON 967', 2698630, 2099012, 'WWW.FRISAC.COM', 'VENTAS@FRISAC.COM', '20040102', '', '', '', '', ''), 
(27, 1, 0, 1, 2, '967735800', 'MACRO FOOD S.A.', 'MACRO FOOD S.A.', 'ELABORACION DE ALIMENTOS', '', 'CARLOS PEZOA VELIZ N0220', 367829, 0, '', '', '20040102', '', '', '', '', ''), 
(28, 1, 0, 1, 2, '965767908', 'MARIA ANGELICA VANNI LTDA.', 'MARIA ANGELICA VANNI LTDA.', 'FABRICA DE BANDEJAS DE CARTON', '', 'BAQUEDANO N229', 498047, 498047, '', 'VANNI@ENTELCHILE.NET', '20041014', '', '', '', '', ''), 
(29, 1, 0, 2, 2, '796620803', 'AGRICOLA DON POLLO LTDA.', 'AGRICOLA DON POLLO LTDA.', 'FAENACION DE AVES Y COMERCIALIZACION DE PRODUCTOS ALIMENTICIOS', '', 'CAMINO EL  MARISCAL LA PINTANA', 3890500, 3890598, 'WWW.DONPOLLO.CL', '', '20041014', '', '', '', '', ''), 
(30, 1, 0, 1, 2, '52770424', 'FRIO JB', 'JOSE ABEL BREVIS GALVARINO', 'SERVICIO TECNICO', '', 'ANTONIO RENDIC N5538', 234331, 475958, '', 'FRIOJB@LATINMAIL.COM', '20041014', '', '', '', '', ''), 
(31, 1, 0, 1, 2, '027145221', 'JUAN FERNANDEZ VARGAS', 'JUAN FERNANDEZ VARGAS', 'REPARACION Y MANTENCION DE EQUIPOS CONTRA EL FUEGO', '', 'VALDIVIA N5175', 265413, 251661, '', 'JFVSERVICIOS@VTR.NET', '20041014', '', '', '', '', ''), 
(32, 1, 0, 1, 2, '105038844', 'TRENDY', 'MICAELA AVILA BUSTAMANTE', 'DISTRIBUIDORA DE PRODUCTOS ALIMENTICIOS', '', 'JUAN GUTENBERG N 452 GALPON 11', 211531, 0, '', '', '20041014', '', '', '', '', ''), 
(33, 1, 0, 2, 2, '944790004', 'SODIMAC S.A.', 'SODIMAC S.A.', 'DISTRIBUIDORA DRE MATERIALES DE CONSTRUCCION', '', 'AVDA.PRESIDENTE EDUARDO FREI M. N3092', 0, 0, '', '', '20041014', '', '', '', '', ''), 
(34, 1, 0, 2, 2, '965579109', 'ALIMENTOS Y FRUTOS S.A.', 'ALIMENTOS Y FRUTOS S.A.', 'AGROINDUSTRIA', '', 'LO ECHEVERS N 250', 2678000, 7390101, 'WWW.ALIFRUT.CL', 'ALIFRUT@ALIFRUT.CL', '20041014', '', '', '', '', ''), 
(36, 1, 0, 1, 2, '77202570K', 'HIPERMERCADO ANTOFAGASTA LTDA.', 'LIDER', 'SUPERMERCADO', '', 'ZENTENO N21', 0, 0, '', '', '20041014', '', '', '', '', ''), 
(37, 1, 0, 2, 2, '965244107', 'EMBOTELLADORAS UNIDAS S.A.', 'EMBOTELLADORAS CHILENAS UNIDAS S.A.', 'DISTRIBUCION BEBIDAS ANALCOHOLICAS', '', 'EDUARDO FREI M. 1500', 4274000, 4274570, '', '', '20041014', '', '', '', '', ''), 
(38, 1, 0, 1, 2, '057206764', 'MERCERIA TAL TAL', 'GUMERCINDO ENRIQUE LILLO CORTES', 'MERCERIA MAESTRANZA', '', 'TALTAL 669', 260089, 269580, '', '', '20041014', '', '', '', '', ''), 
(39, 1, 0, 1, 2, '055957592', 'DOROTEA CAYO SUPANTA', 'DOROTEA CAYO SUPANTA', 'DISTRIBUIDORA DE FRUTOS', '', 'IQUIQUE 4772', 269404, 0, '', '', '20041014', '', '', '', '', ''), 
(40, 1, 0, 1, 2, '07675053K', 'HUGO LEON MONTECINO', 'HUGO LEON MONTECINOS', 'DISTRIBUIDOR DE PRODUCTOS ALIMENTICIOS', '', 'AVDA.ANTONIO RENDIC 5170', 224878, 224601, '', '', '20041014', '', '', '', '', ''), 
(41, 1, 0, 1, 2, '086289377', 'MAURICIO ARTAL MAC-MAHON', 'ARTAL', 'VENTA DE ARTICULOS DE PLASTICO', '', 'J,S,OSSA 2414', 410524, 410524, '', 'ARTAL@ENVASEALIMENTACION@ENTELCHILE.NET', '20041014', '', '', '', '', ''), 
(42, 1, 0, 4, 2, '780032405', 'FRISAC S.A.', 'FRISAC', 'PRODUCTOS AGRICOLAS CONGELADOS', '', 'CAMINO A MONTE BLANCO S/N', 411806, 411273, 'WWW.FRISAC.COM', 'VENTAS@FRISAC.COM', '20041014', '', '', '', '', ''), 
(43, 1, 0, 1, 2, '92196000K', 'AGICOLA INDUSTRIAL LO VALLEDOR AASA S.A.', 'EMPRESAS AASA.', 'INDUSTRIA AUTOMOTRIZ Y AGRICOLA INDUSTRIAL', '', 'HUASCO 310 BARRIO INDUSTRIAL', 223309, 227620, 'WWW.AASA.CL', '', '20041014', '', '', '', '', ''), 
(44, 1, 0, 1, 2, '046556690', 'FRANCISCA CONTRERAS VILLALOBOS', 'FRANCISCA CONTRERAS VILLALOBOS', '', '', 'LA FLORIDA N195 VILLA EL MIRADOR', 211970, 0, '', '', '20041014', '', '', '', '', '');
#----------------------------
# Table structure for comuna
#----------------------------
CREATE TABLE `comuna` (
  `id_comuna` int(11) NOT NULL auto_increment,
  `id_ciudad` int(11) NOT NULL default '0',
  `nombre` varchar(255) NOT NULL default '0',
  PRIMARY KEY  (`id_comuna`),
  KEY `id_ciudad` (`id_ciudad`),
  CONSTRAINT `comuna_ibfk_1` FOREIGN KEY (`id_ciudad`) REFERENCES `ciudad` (`id_ciudad`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
#----------------------------
# Records for table comuna
#----------------------------


insert  into comuna values 
(1, 1, 'Antofagasta'), 
(2, 2, 'Santiago'), 
(3, 3, 'Iquique');
#----------------------------
# Table structure for contacto
#----------------------------
CREATE TABLE `contacto` (
  `id_contacto` int(11) NOT NULL auto_increment,
  `id_cliente_proveedor` int(11) NOT NULL default '0',
  `nombre` varchar(255) NOT NULL default '',
  `apellido` varchar(255) NOT NULL default '',
  `area` varchar(255) NOT NULL default '',
  `telefono` int(11) NOT NULL default '0',
  `fax` int(11) NOT NULL default '0',
  `movil` int(11) NOT NULL default '0',
  `email` varchar(255) NOT NULL default '',
  `extra1` varchar(255) NOT NULL default '',
  `extra2` varchar(255) NOT NULL default '',
  `extra3` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id_contacto`),
  KEY `id_cliente_proveedor` (`id_cliente_proveedor`),
  CONSTRAINT `contacto_ibfk_1` FOREIGN KEY (`id_cliente_proveedor`) REFERENCES `cliente_proveedor` (`id_cliente_proveedor`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
#----------------------------
# No records for table contacto
#----------------------------

#----------------------------
# Table structure for contador
#----------------------------
CREATE TABLE `contador` (
  `id_contador` int(11) NOT NULL auto_increment,
  `id_empresa` int(11) NOT NULL default '0',
  `nombre` varchar(255) NOT NULL default '',
  `apellido` varchar(255) NOT NULL default '',
  `rut` varchar(255) NOT NULL default '',
  `telefono` int(11) NOT NULL default '0',
  `movil` int(11) NOT NULL default '0',
  `email` varchar(255) NOT NULL default '',
  `extra1` varchar(255) NOT NULL default '',
  `extra2` varchar(255) NOT NULL default '',
  `extra3` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id_contador`),
  KEY `id_empresa` (`id_empresa`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
#----------------------------
# Records for table contador
#----------------------------


insert  into contador values 
(1, 0, 'NELSON', 'CAMPUSANO', '13.759.823-K', 449200, 0, 'contabilida@addcorp.cl', '', '', '');
#----------------------------
# Table structure for cuenta
#----------------------------
CREATE TABLE `cuenta` (
  `id_cuenta` int(11) NOT NULL auto_increment,
  `id_nivel_plan_cuenta` int(11) NOT NULL default '0',
  `id_usuario` int(11) NOT NULL default '0',
  `codigo` varchar(50) NOT NULL default '',
  `nombre` varchar(255) NOT NULL default '',
  `descripcion` text NOT NULL,
  `fecha_creacion` varchar(14) NOT NULL default '',
  `fecha_modificacion` varchar(14) NOT NULL default '',
  `imp` tinyint(4) NOT NULL default '0',
  `hab` tinyint(4) NOT NULL default '0',
  `cc` tinyint(4) NOT NULL default '0',
  `bco` tinyint(4) NOT NULL default '0',
  `des` tinyint(4) NOT NULL default '0',
  `ana` tinyint(4) NOT NULL default '0',
  `fjo` tinyint(4) NOT NULL default '0',
  `mov` tinyint(4) NOT NULL default '0',
  `clasificacion` varchar(100) NOT NULL default '',
  `actividad` varchar(255) NOT NULL default '',
  `codigo_unitario` varchar(50) NOT NULL default '',
  `formato_cuenta` varchar(10) NOT NULL default '',
  `id_plan_cuenta` int(11) NOT NULL default '0',
  `extra4` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id_cuenta`),
  KEY `id_nivel_plan_cuenta` (`id_nivel_plan_cuenta`),
  CONSTRAINT `cuenta_ibfk_2` FOREIGN KEY (`id_nivel_plan_cuenta`) REFERENCES `nivel_plan_cuenta` (`id_nivel_plan_cuenta`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
#----------------------------
# Records for table cuenta
#----------------------------


insert  into cuenta values 
(10, 35, 0, '1101010001', 'Caja Administracin', '', '', '', 1, 0, 0, 0, 0, 0, 0, 0, '', '', '1', '4', 14, ''), 
(11, 40, 0, '3101010001', 'Materiales', '', '', '', 1, 1, 1, 0, 0, 0, 0, 0, '', '', '1', '4', 14, ''), 
(12, 40, 0, '3101010002', 'Mano de Obra', '', '', '', 1, 1, 1, 0, 0, 0, 0, 0, '', '', '2', '4', 14, ''), 
(13, 40, 0, '3101010003', 'Suministros y Servicios', '', '', '', 1, 1, 1, 0, 0, 0, 0, 0, '', '', '3', '4', 14, '');
#----------------------------
# Table structure for detalle_documento_compra
#----------------------------
CREATE TABLE `detalle_documento_compra` (
  `id_detalle_documento_compra` int(11) NOT NULL auto_increment,
  `id_documento_compra` int(11) NOT NULL default '0',
  `cod_producto` varchar(50) NOT NULL default '',
  `descripcion_producto` varchar(255) NOT NULL default '',
  `cantidad` int(11) NOT NULL default '0',
  `unidad` varchar(50) NOT NULL default '',
  `exento` float NOT NULL default '0',
  `valor_impuesto` float NOT NULL default '0',
  `porcentaje_descuento` float NOT NULL default '0',
  `monto_descuento` float NOT NULL default '0',
  `precio_neto_unitario` float NOT NULL default '0',
  `total_neto` float NOT NULL default '0',
  `iva` float NOT NULL default '0',
  `total` float NOT NULL default '0',
  `extra1` varchar(255) NOT NULL default '',
  `extra2` varchar(255) NOT NULL default '',
  `extra3` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id_detalle_documento_compra`),
  KEY `id_documento_compra` (`id_documento_compra`),
  CONSTRAINT `detalle_documento_compra_ibfk_1` FOREIGN KEY (`id_documento_compra`) REFERENCES `documento_compra` (`id_documento_compra`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
#----------------------------
# Records for table detalle_documento_compra
#----------------------------


insert  into detalle_documento_compra values 
(7, 2, '1', 'Gasolina 95 Octanos', 41, 'litros', '0', '0', '0', '0', '0', '13275', '2522', '23110', '', '', '');
#----------------------------
# Table structure for documento_compra
#----------------------------
CREATE TABLE `documento_compra` (
  `id_documento_compra` int(11) NOT NULL auto_increment,
  `id_documento_compra_fk` int(11) NOT NULL default '0',
  `id_proveedor` int(11) NOT NULL default '0',
  `id_empresa` int(11) NOT NULL default '0',
  `id_usuario` int(11) NOT NULL default '0',
  `tipo_documento` varchar(255) NOT NULL default '',
  `folio` int(11) NOT NULL default '0',
  `correlativo` int(11) NOT NULL default '0',
  `correlativo_sufijo` int(11) NOT NULL default '0',
  `numero_documento` int(11) NOT NULL default '0',
  `fecha_digitacion` varchar(14) NOT NULL default '',
  `fecha_documento` varchar(14) NOT NULL default '',
  `fecha_cancelacion` varchar(14) NOT NULL default '',
  `fecha_modificacion` varchar(14) NOT NULL default '',
  `mes_proceso` int(11) NOT NULL default '0',
  `ano_proceso` int(11) NOT NULL default '0',
  `total_descuento` float NOT NULL default '0',
  `total_neto` float NOT NULL default '0',
  `total_exento` float NOT NULL default '0',
  `total_impuesto` float NOT NULL default '0',
  `total_iva` float NOT NULL default '0',
  `total_bruto` float NOT NULL default '0',
  `total_saldos` float NOT NULL default '0',
  `total_pagos` float NOT NULL default '0',
  `orden_compra` float NOT NULL default '0',
  `estado_compra` float NOT NULL default '0',
  `forma_pago` float NOT NULL default '0',
  `tipo_pago` float(11,0) NOT NULL default '0',
  `numero_cheque` int(11) NOT NULL default '0',
  `fecha_vto_cheque` varchar(14) NOT NULL default '',
  `extra1` varchar(255) NOT NULL default '',
  `extra2` varchar(255) NOT NULL default '',
  `extra3` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id_documento_compra`),
  KEY `id_empresa` (`id_empresa`),
  CONSTRAINT `documento_compra_ibfk_1` FOREIGN KEY (`id_empresa`) REFERENCES `empresa` (`id_empresa`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
#----------------------------
# Records for table documento_compra
#----------------------------


insert  into documento_compra values 
(2, 0, 10, 2, 29, '1', 1, 1, 9, 1, '20040930', '20040930', '', '20040930', 9, 2004, '0', '13275', '0', '0', '2522', '23110', '0', '0', '1', '0', '0', '0', 0, '', '', '', '');
#----------------------------
# Table structure for empresa
#----------------------------
CREATE TABLE `empresa` (
  `id_empresa` int(11) NOT NULL auto_increment,
  `id_contador` int(11) NOT NULL default '0',
  `id_ciudad` int(11) NOT NULL default '0',
  `id_plan_cuenta` varchar(255) NOT NULL default '',
  `id_comuna` int(11) NOT NULL default '0',
  `rut` varchar(10) NOT NULL default '',
  `nombre` varchar(255) NOT NULL default '',
  `razon_social` varchar(255) NOT NULL default '',
  `codigo_act_economica` varchar(50) NOT NULL default '',
  `giro` varchar(255) NOT NULL default '',
  `direccion` varchar(255) NOT NULL default '',
  `telefono` int(11) NOT NULL default '0',
  `fax` int(11) NOT NULL default '0',
  `website` varchar(255) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `mutual` varchar(255) NOT NULL default '',
  `ccaf` varchar(255) NOT NULL default '',
  `extra1` varchar(255) NOT NULL default '',
  `extra2` varchar(255) NOT NULL default '',
  `extra3` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id_empresa`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
#----------------------------
# Records for table empresa
#----------------------------


insert  into empresa values 
(1, 1, 1, '0', 1, '12.613.859', 'VERONICA ALEJANDRA GARAY CORTES', 'VERONICA ALEJANDRA GARAY CORTES', '', 'SERVICIO DE COMIDAS PREPARADAS', 'AV. MEJILLONES N4770', 260670, 260670, '', '', '', '', '', '', ''), 
(2, 1, 1, '14', 0, '', 'Empresa de Prueba!', 'Empresa de Prueba!', '', '', '33333', 0, 0, '', '', '', '', '', '', ''), 
(3, 1, 1, '0', 0, '778870002', 'ADD CORP S.A.', 'ADD CORP S.A.', '83291', 'ASESORIAS', 'ANTONINO TORO 1125', 449200, 449200, '', 'CONTABILIDAD@ADDCORP.CL', '', '', '', '', '');
#----------------------------
# Table structure for nivel_plan_cuenta
#----------------------------
CREATE TABLE `nivel_plan_cuenta` (
  `id_nivel_plan_cuenta` int(11) NOT NULL auto_increment,
  `id_nivel_plan_cuenta_padre` int(11) NOT NULL default '0',
  `id_plan_cuenta` int(11) NOT NULL default '0',
  `id_usuario` int(11) NOT NULL default '0',
  `formato_nivel` varchar(10) NOT NULL default '',
  `nivel` smallint(6) NOT NULL default '0',
  `nombre` varchar(100) NOT NULL default '',
  `descripcion` text NOT NULL,
  `fecha_creacion` varchar(14) NOT NULL default '',
  `fecha_modificacion` varchar(14) NOT NULL default '',
  `es_ultimo_nivel` smallint(6) NOT NULL default '0',
  `codigo` varchar(50) NOT NULL default '',
  `codigo_unitario` varchar(50) NOT NULL default '',
  `extra3` varchar(50) NOT NULL default '',
  `extra4` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id_nivel_plan_cuenta`),
  KEY `id_nivel_plan_cuenta_padre` (`id_nivel_plan_cuenta_padre`),
  KEY `id_plan_cuenta` (`id_plan_cuenta`),
  CONSTRAINT `nivel_plan_cuenta_ibfk_1` FOREIGN KEY (`id_nivel_plan_cuenta_padre`) REFERENCES `nivel_plan_cuenta` (`id_nivel_plan_cuenta`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `nivel_plan_cuenta_ibfk_2` FOREIGN KEY (`id_plan_cuenta`) REFERENCES `plan_cuenta` (`id_plan_cuenta`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
#----------------------------
# Records for table nivel_plan_cuenta
#----------------------------


insert  into nivel_plan_cuenta values 
(1, 1, 1, 0, '', 0, 'NivelPlanCuentaCabecera', '', '', '', 0, '', '', '', ''), 
(32, 1, 14, 0, '1', 1, 'Activo', '', '', '', 0, '1', '1', '', ''), 
(33, 32, 14, 0, '1', 1, 'Activo Circulante', '', '', '', 0, '11', '1', '', ''), 
(34, 33, 14, 0, '2', 1, 'Disponible', '', '', '', 0, '1101', '1', '', ''), 
(35, 34, 14, 0, '2', 1, 'Caja', '', '', '', 1, '110101', '1', '', ''), 
(37, 1, 14, 0, '1', 1, 'Perdida', '', '', '', 0, '3', '3', '', ''), 
(38, 37, 14, 0, '1', 1, 'Costos Operacionales', '', '', '', 0, '31', '1', '', ''), 
(39, 38, 14, 0, '2', 1, 'Costos de Explotacin', '', '', '', 0, '3101', '1', '', ''), 
(40, 39, 14, 0, '2', 1, 'Costo de Obras', '', '', '', 1, '310101', '1', '', '');
#----------------------------
# Table structure for plan_cuenta
#----------------------------
CREATE TABLE `plan_cuenta` (
  `id_plan_cuenta` int(11) NOT NULL auto_increment,
  `id_usuario` int(11) NOT NULL default '0',
  `nombre` varchar(255) NOT NULL default '',
  `descripcion` longtext NOT NULL,
  `formato` varchar(255) NOT NULL default '',
  `fecha_creacion` varchar(14) NOT NULL default '',
  `extra1` varchar(255) NOT NULL default '',
  `extra2` varchar(255) NOT NULL default '',
  `extra3` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id_plan_cuenta`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
#----------------------------
# Records for table plan_cuenta
#----------------------------


insert  into plan_cuenta values 
(1, 0, 'PlanCuentaCabecera', '', '', '', '', '', ''), 
(14, 29, '', '', '', '20041015194629', '', '', '');
#----------------------------
# Table structure for region
#----------------------------
CREATE TABLE `region` (
  `id_region` int(11) NOT NULL auto_increment,
  `numero` varchar(10) NOT NULL default '',
  `nombre` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id_region`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
#----------------------------
# Records for table region
#----------------------------


insert  into region values 
(1, 'I', 'Tarapac'), 
(2, 'II', 'Antofagasta'), 
(3, 'III', 'Atacama'), 
(4, 'IV', 'Coquimbo'), 
(5, 'V', 'Valparaiso'), 
(6, 'VI', 'L.General B.O\'Higgins'), 
(7, 'VII', 'Maule'), 
(8, 'VIII', 'Bio-Bio'), 
(9, 'IX', 'Araucana'), 
(10, 'X', 'Los Lagos'), 
(11, 'XI', 'Aysn'), 
(12, 'XII', 'Magallanes'), 
(13, 'RM', 'Metropolitana');
#----------------------------
# Table structure for representante_legal
#----------------------------
CREATE TABLE `representante_legal` (
  `id_representante_legal` int(11) NOT NULL auto_increment,
  `id_empresa` int(11) NOT NULL default '0',
  `nombre` varchar(255) NOT NULL default '',
  `apellido` varchar(255) NOT NULL default '',
  `rut` varchar(10) NOT NULL default '',
  `extra1` varchar(255) NOT NULL default '',
  `extra2` varchar(255) NOT NULL default '',
  `extra3` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id_representante_legal`),
  KEY `id_empresa` (`id_empresa`),
  CONSTRAINT `representante_legal_ibfk_1` FOREIGN KEY (`id_empresa`) REFERENCES `empresa` (`id_empresa`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
#----------------------------
# Records for table representante_legal
#----------------------------


insert  into representante_legal values 
(1, 2, 'Nombre Prueba', 'Nombre Prueba', '14141414-4', '', '', '');
#----------------------------
# Table structure for sucursal
#----------------------------
CREATE TABLE `sucursal` (
  `id_sucursal` int(11) NOT NULL auto_increment,
  `id_empresa` int(11) NOT NULL default '0',
  `id_comuna` int(11) NOT NULL default '0',
  `id_ciudad` int(11) NOT NULL default '0',
  `rut` varchar(10) NOT NULL default '',
  `codigo` varchar(50) NOT NULL default '',
  `direccion` varchar(255) NOT NULL default '',
  `telefono` int(11) NOT NULL default '0',
  `fax` int(11) NOT NULL default '0',
  `email` varchar(255) NOT NULL default '',
  `extra1` varchar(255) NOT NULL default '',
  `extra2` varchar(255) NOT NULL default '',
  `extra3` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id_sucursal`),
  KEY `id_empresa` (`id_empresa`),
  CONSTRAINT `sucursal_ibfk_1` FOREIGN KEY (`id_empresa`) REFERENCES `empresa` (`id_empresa`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
#----------------------------
# Records for table sucursal
#----------------------------


insert  into sucursal values 
(1, 2, 0, 1, '222', '', 'Coquimbo 812', 4545454, 0, '', '', '', '');
#----------------------------
# Table structure for usuario
#----------------------------
CREATE TABLE `usuario` (
  `id_usuario` int(11) NOT NULL auto_increment,
  `id_contacto` int(11) NOT NULL default '0',
  `login` varchar(255) NOT NULL default '',
  `password` varchar(255) NOT NULL default '',
  `privilegio` int(11) NOT NULL default '0',
  `extra1` varchar(255) NOT NULL default '',
  `extra2` varchar(255) NOT NULL default '',
  `extra3` varchar(255) NOT NULL default '',
  UNIQUE KEY `id_usuario` (`id_usuario`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
#----------------------------
# Records for table usuario
#----------------------------


insert  into usuario values 
(1, 0, 'itek', '586848b0c4e6923a02aa4a673e4ea345', 11111, '', '', ''), 
(29, 0, 'mmarchant', 'dfc9eb5e3b712e2fabde3c8d8af76249', 11111, '', '', ''), 
(30, 0, 'nelson', '863453f38ea5b857d65f1a7090c9abc4', 11111, '', '', '');

