<?

//------------------------------------------------------------------------------
//	CLASE LOGICA
//------------------------------------------------------------------------------

class Boleta{
	//ES UN CONTENEDOR DE ATRIBUTOS SETEADOS EN TIEMPO DE EJECUCION

	private $id_boleta;
	private $id_profesional;
	private $id_contribuyente;
	private $correlativo;
	private $id_comprobante;
	private $descripcion;
	private $id_centro_costo;
	private $id_item_gasto;
	private $numero_boleta;
	private $fecha_creacion;
	private $fecha_emision;
	private $fecha_proceso;
	private $total_neto;
	private $impuesto;
	private $total_bruto;

	private $total_saldos;
	private $estado;
	private $fecha_cancelacion;
	private $id_sucursal;
	private $descripcion_global;
	private $descripcion_detalle;
	
	private $global_detalle_vista;

	private $nombre_centro_costo;
	private $nombre_cuenta;
	
	private $rut;
	private $nombre;
	
	private $nombre_estado;
	private $total_pagos;

	//CONSTRUCTOR
	public function __construct ($Boleta_BD)
	{
		if ($Boleta_BD){
			$this->id_boleta = $Boleta_BD->get_id_boleta();
			$this->id_profesional = $Boleta_BD->get_id_profesional();
			$this->id_contribuyente = $Boleta_BD->get_id_contribuyente();
			$this->correlativo = $Boleta_BD->get_correlativo();
			$this->id_comprobante = $Boleta_BD->get_id_comprobante();
			$this->descripcion = $Boleta_BD->get_descripcion();
			$this->id_centro_costo = $Boleta_BD->get_id_centro_costo();
			$this->id_item_gasto = $Boleta_BD->get_id_item_gasto();
			$this->numero_boleta = $Boleta_BD->get_numero_boleta();
			$this->fecha_creacion = $Boleta_BD->get_fecha_creacion();
			$this->fecha_emision = $Boleta_BD->get_fecha_emision();
			$this->fecha_proceso = $Boleta_BD->get_fecha_proceso();
			$this->total_neto = $Boleta_BD->get_total_neto();
			$this->impuesto = $Boleta_BD->get_impuesto();
			$this->total_bruto = $Boleta_BD->get_total_bruto();
			$this->total_saldos = $Boleta_BD->get_total_saldos();
			$this->estado = $Boleta_BD->get_estado();
			$this->fecha_cancelacion = $Boleta_BD->get_fecha_cancelacion();
			$this->id_sucursal = $Boleta_BD->get_id_sucursal();
			switch ($this->descripcion) {
				case 1: $this->descripcion_global = "selected"; $this->global_detalle_vista = "relative"; break;
				case 2: $this->descripcion_detalle = "selected";$this->global_detalle_vista = "none"; break;
			}
			
			$cuenta = Cuenta_getCuenta($this->id_item_gasto);
			if ($cuenta)
				$this->nombre_cuenta = $cuenta->get_codigo()." - ".$cuenta->get_nombre();
				
			$centro_costo = Sub_centro_costo_getSub_centro_costo($this->id_centro_costo);
			if ($centro_costo)
				$this->nombre_centro_costo = $centro_costo->get_nombre_compuesto();
				
			$clog_cp = new Controlador_Logico_Cliente_proveedor();
			$cp = $clog_cp->getCliente_proveedor($this->id_profesional);
			if ($cp){
				$this->nombre = $cp->get_nombre();
				$this->rut    = $cp->get_rut();
			}
			
			switch ($this->estado){
				case "1": $this->nombre_estado = "Abonada";break;
				case "2": $this->nombre_estado = "Cancelada";break;
				default:  $this->nombre_estado = "Impaga";break;
			}
			
			$this->total_pagos = $this->total_neto - $this->total_saldos;
		}
	}

	//------------------------------------------------------------------------------
	//	FUNCIONES GET PARA OBTENER ATRIBUTOS
	//------------------------------------------------------------------------------
	public function get_total_pagos(){
		return ($this->total_pagos);
	}	
	
	public function get_nombre_estado(){
		return ($this->nombre_estado);
	}		
	
	public function get_estado(){
		return ($this->estado);
	}	
	
	public function get_fecha_cancelacion(){
		return ($this->fecha_cancelacion);
	}
	
	public function get_nombre(){
		return ($this->nombre);
	}
	
	public function get_rut(){
		return (format_rut_php($this->rut));
	}
	
	public function get_total_saldos(){
		return ($this->total_saldos);
	}

	public function get_nombre_centro_costo(){
		return ($this->nombre_centro_costo);
	}
	
	public function get_nombre_cuenta(){
		return ($this->nombre_cuenta);
	}
	
	public function get_global_detalle_vista(){
		return ($this->global_detalle_vista);
	}
		
	public function get_descripcion_global(){
		return ($this->descripcion_global);
	}
	
	public function get_descripcion_detalle(){
		return ($this->descripcion_detalle);
	}
	
	public function get_id_boleta(){
		return ($this->id_boleta);
	}

	public function get_id_profesional(){
		return ($this->id_profesional);
	}

	public function get_id_contribuyente(){
		return ($this->id_contribuyente);
	}

	public function get_correlativo(){
		return ($this->correlativo);
	}

	public function get_id_comprobante(){
		return ($this->id_comprobante);
	}

	public function get_descripcion(){
		return ($this->descripcion);
	}

	public function get_id_centro_costo(){
		return ($this->id_centro_costo);
	}

	public function get_id_item_gasto(){
		return ($this->id_item_gasto);
	}

	public function get_numero_documento(){
		return ($this->numero_boleta);
	}

	public function get_numero_boleta(){
		return ($this->numero_boleta);
	}

	public function get_fecha_creacion(){
		return ($this->fecha_creacion);
	}

	public function get_fecha_documento(){
		return ($this->fecha_emision);
	}
	
	public function get_total_exento(){
	}

	public function get_fecha_emision(){
		return ($this->fecha_emision);
	}

	public function get_fecha_proceso(){
		return ($this->fecha_proceso);
	}

	public function get_fecha_emision_cal(){
		if ($this->fecha_emision)
			return (convertirFechaBD_fecha($this->fecha_emision));
		else
			return "";
	}

	public function get_total_neto(){
		return ($this->total_neto);
	}

	public function get_total_iva(){
		return ($this->impuesto);
	}

	public function get_impuesto(){
		return ($this->impuesto);
	}

	public function get_total_bruto(){
		return ($this->total_bruto);
	}

	public function get_id_sucursal(){
		return ($this->id_sucursal);
	}
	//------------------------------------------------------------------------------
	//	FUNCIONES SET PARA SETEAR ATRIBUTOS
	//------------------------------------------------------------------------------
	public function set_total_pagos($total_pagos){
		
	}
	
	public function set_estado($estado){
		$this->estado = $estado;
	}
	
	public function set_fecha_cancelacion($fecha_cancelacion){
		$this->fecha_cancelacion = $fecha_cancelacion;
	}

	public function set_total_saldos($total_saldos){
		$this->total_saldos = $total_saldos;
	}

	public function set_id_boleta($id_boleta){
		$this->id_boleta = $id_boleta;
	}

	public function set_id_profesional($id_profesional){
		$this->id_profesional = $id_profesional;
	}

	public function set_id_contribuyente($id_contribuyente){
		$this->id_contribuyente = $id_contribuyente;
	}

	public function set_correlativo($correlativo){
		$this->correlativo = $correlativo;
	}

	public function set_id_comprobante($id_comprobante){
		$this->id_comprobante = $id_comprobante;
	}

	public function set_descripcion($descripcion){
		$this->descripcion = $descripcion;
	}

	public function set_id_centro_costo($id_centro_costo){
		$this->id_centro_costo = $id_centro_costo;
	}

	public function set_id_item_gasto($id_item_gasto){
		$this->id_item_gasto = $id_item_gasto;
	}

	public function set_numero_boleta($numero_boleta){
		$this->numero_boleta = $numero_boleta;
	}

	public function set_fecha_creacion($fecha_creacion){
		$this->fecha_creacion = $fecha_creacion;
	}

	public function set_fecha_emision($fecha_emision){
		$this->fecha_emision = $fecha_emision;
	}

	public function set_fecha_proceso($fecha_proceso){
		$this->fecha_proceso = $fecha_proceso;
	}

	public function set_total_neto($total_neto){
		$this->total_neto = $total_neto;
	}

	public function set_impuesto($impuesto){
		$this->impuesto = $impuesto;
	}

	public function set_total_bruto($total_bruto){
		$this->total_bruto = $total_bruto;
	}

	public function set_id_sucursal($id_sucursal){
		$this->id_sucursal = $id_sucursal;
	}

}
//------------------------------------------------------------------------------
//	FIN CLASE
//------------------------------------------------------------------------------

?>
