<?

//------------------------------------------------------------------------------
//	CLASE LOGICA
//------------------------------------------------------------------------------

class boleta_venta{
	//ES UN CONTENEDOR DE ATRIBUTOS SETEADOS EN TIEMPO DE EJECUCION

	private $id_boleta_venta;
	private $id_profesional;
	private $id_contribuyente;
	private $correlativo;
	private $id_empresa;
	private $id_comprobante;
	private $id_centro_costo;
	private $id_item_gasto;
	private $numero_boleta_hasta_venta;
	private $numero_boleta_desde_venta;
	private $fecha_creacion;
	private $fecha_emision;
	private $fecha_proceso;
	private $total_neto;
	private $impuesto;
	private $total_bruto;
	private $id_sucursal;
	private $id_comprobante_global;
	private $id_comprobante_detalle;
	
	private $global_detalle_vista;
	
	private $fecha_emision_calendario;

	//CONSTRUCTOR
	public function __construct ($boleta_venta_BD)
	{
		if ($boleta_venta_BD){
			$this->id_boleta_venta = $boleta_venta_BD->get_id_boleta_venta();
			$this->id_profesional = $boleta_venta_BD->get_id_profesional();
			$this->id_contribuyente = $boleta_venta_BD->get_id_contribuyente();
			$this->correlativo = $boleta_venta_BD->get_correlativo();
			$this->id_empresa = $boleta_venta_BD->get_id_empresa();
			$this->id_comprobante = $boleta_venta_BD->get_id_comprobante();
			$this->id_centro_costo = $boleta_venta_BD->get_id_centro_costo();
			$this->id_item_gasto = $boleta_venta_BD->get_id_item_gasto();
			$this->numero_boleta_hasta_venta = $boleta_venta_BD->get_numero_boleta_hasta_venta();
			$this->numero_boleta_desde_venta = $boleta_venta_BD->get_numero_boleta_desde_venta();
			$this->fecha_creacion = $boleta_venta_BD->get_fecha_creacion();
			$this->fecha_emision = $boleta_venta_BD->get_fecha_emision();
			$this->fecha_proceso = $boleta_venta_BD->get_fecha_proceso();
			$this->total_neto = $boleta_venta_BD->get_total_neto();
			$this->impuesto = $boleta_venta_BD->get_impuesto();
			$this->total_bruto = $boleta_venta_BD->get_total_bruto();
			$this->id_sucursal = $boleta_venta_BD->get_id_sucursal();
			switch ($this->id_comprobante) {
				case 1: $this->id_comprobante_global = "selected"; $this->global_detalle_vista = "relative"; break;
				case 2: $this->id_comprobante_detalle = "selected";$this->global_detalle_vista = "none"; break;
			}
			
			
			if ($this->fecha_emision)
				$this->fecha_emision_calendario = convertirFechaBD_fecha($this->fecha_emision);
			//debug($this);
		}
	}

	//------------------------------------------------------------------------------
	//	FUNCIONES GET PARA OBTENER ATRIBUTOS
	//------------------------------------------------------------------------------
	

	
	public function get_fecha_emision_calendario(){
		return ($this->fecha_emision_calendario);
	}
	
	public function get_global_detalle_vista(){
		return ($this->global_detalle_vista);
	}
		
	public function get_id_comprobante_global(){
		return ($this->id_comprobante_global);
	}
	
	public function get_id_comprobante_detalle(){
		return ($this->id_comprobante_detalle);
	}
	
	public function get_id_boleta_venta(){
		return ($this->id_boleta_venta);
	}

	public function get_id_profesional(){
		return ($this->id_profesional);
	}

	public function get_id_contribuyente(){
		return ($this->id_contribuyente);
	}

	public function get_correlativo(){
		return ($this->correlativo);
	}

	public function get_id_empresa(){
		return ($this->id_empresa);
	}

	public function get_id_comprobante(){
		return ($this->id_comprobante);
	}

	public function get_id_centro_costo(){
		return ($this->id_centro_costo);
	}

	public function get_id_item_gasto(){
		return ($this->id_item_gasto);
	}

	public function get_numero_boleta_hasta_venta(){
		return ($this->numero_boleta_hasta_venta);
	}
	
	public function get_numero_boleta_desde_venta(){
		return ($this->numero_boleta_desde_venta);
	}

	public function get_fecha_creacion(){
		return ($this->fecha_creacion);
	}

	public function get_fecha_emision(){
		return ($this->fecha_emision);
	}

	public function get_fecha_proceso(){
		return ($this->fecha_proceso);
	}

	public function get_total_neto(){
		return ($this->total_neto);
	}

	public function get_impuesto(){
		return ($this->impuesto);
	}

	public function get_total_bruto(){
		return ($this->total_bruto);
	}

	public function get_id_sucursal(){
		return ($this->id_sucursal);
	}
	//------------------------------------------------------------------------------
	//	FUNCIONES SET PARA SETEAR ATRIBUTOS
	//------------------------------------------------------------------------------

	public function set_id_boleta_venta($id_boleta_venta){
		$this->id_boleta_venta = $id_boleta_venta;
	}

	public function set_id_profesional($id_profesional){
		$this->id_profesional = $id_profesional;
	}

	public function set_id_contribuyente($id_contribuyente){
		$this->id_contribuyente = $id_contribuyente;
	}

	public function set_correlativo($correlativo){
		$this->correlativo = $correlativo;
	}

	public function set_id_empresa($id_empresa){
		$this->id_empresa = $id_empresa;
	}

	public function set_id_comprobante($id_comprobante){
		$this->id_comprobante = $id_comprobante;
	}

	public function set_id_centro_costo($id_centro_costo){
		$this->id_centro_costo = $id_centro_costo;
	}

	public function set_id_item_gasto($id_item_gasto){
		$this->id_item_gasto = $id_item_gasto;
	}

	public function set_numero_boleta_desde_venta($numero_boleta_desde_venta){
		$this->numero_boleta_desde_venta = $numero_boleta_desde_venta;
	}
	
	public function set_numero_boleta_hasta_venta($numero_boleta_hasta_venta){
		$this->numero_boleta_hasta_venta = $numero_boleta_hasta_venta;
	}	

	public function set_fecha_creacion($fecha_creacion){
		$this->fecha_creacion = $fecha_creacion;
	}

	public function set_fecha_emision($fecha_emision){
		$this->fecha_emision = $fecha_emision;
	}

	public function set_fecha_proceso($fecha_proceso){
		$this->fecha_proceso = $fecha_proceso;
	}

	public function set_total_neto($total_neto){
		$this->total_neto = $total_neto;
	}

	public function set_impuesto($impuesto){
		$this->impuesto = $impuesto;
	}

	public function set_total_bruto($total_bruto){
		$this->total_bruto = $total_bruto;
	}

	public function set_id_sucursal($id_sucursal){
		$this->id_sucursal = $id_sucursal;
	}

}
//------------------------------------------------------------------------------
//	FIN CLASE
//------------------------------------------------------------------------------

?>
