<?

//------------------------------------------------------------------------------
//	CLASE LOGICA
//------------------------------------------------------------------------------

class Cont_comprobante_pago{
	//ES UN CONTENEDOR DE ATRIBUTOS SETEADOS EN TIEMPO DE EJECUCION

	private $id_comprobante_pago;
	private $id_cliente_proveedor;
	private $id_documento;
	private $tipo;
	private $forma_pago;
	private $abono;
	private $glosa;
	private $fecha_abono;
	private $fecha_digitacion;
	private $numero_cheque;
	private $fecha_cheque;
	private $estado;
	private $id_comprobante_contable;
	private $id_empresa_seleccionada;
	private $id_sucursal;
	private $numero_recibo;
	private $nombre_tipo;
	private $fecha_abono_cal;
	
	private $rut_cliente_proveedor;
	private $nombre_cliente_proveedor;
	
	

	//CONSTRUCTOR
	public function __construct ($Cont_comprobante_pago_BD)
	{
		if ($Cont_comprobante_pago_BD){
			$this->id_comprobante_pago = $Cont_comprobante_pago_BD->get_id_comprobante_pago();
			$this->id_cliente_proveedor = $Cont_comprobante_pago_BD->get_id_cliente_proveedor();
			$this->id_documento = $Cont_comprobante_pago_BD->get_id_documento();
			$this->tipo = $Cont_comprobante_pago_BD->get_tipo();
			$this->forma_pago = $Cont_comprobante_pago_BD->get_forma_pago();
			$this->abono = $Cont_comprobante_pago_BD->get_abono();
			$this->glosa = $Cont_comprobante_pago_BD->get_glosa();
			$this->fecha_abono = $Cont_comprobante_pago_BD->get_fecha_abono();
			$this->fecha_digitacion = $Cont_comprobante_pago_BD->get_fecha_digitacion();
			$this->numero_cheque = $Cont_comprobante_pago_BD->get_numero_cheque();
			$this->fecha_cheque = $Cont_comprobante_pago_BD->get_fecha_cheque();
			$this->estado = $Cont_comprobante_pago_BD->get_estado();
			$this->id_comprobante_contable = $Cont_comprobante_pago_BD->get_id_comprobante_contable();
			$this->id_empresa_seleccionada = $Cont_comprobante_pago_BD->get_id_empresa_seleccionada();
			$this->id_sucursal = $Cont_comprobante_pago_BD->get_id_sucursal();
			$this->numero_recibo = $Cont_comprobante_pago_BD->get_numero_recibo();
			
			$clog_cliente_proveedor = new Controlador_Logico_Cliente_proveedor();
			$cliente_proveedor = new Cliente_proveedor();
			$cliente_proveedor = $clog_cliente_proveedor->getCliente_proveedor($this->id_cliente_proveedor);
			if ($cliente_proveedor)
			{
				$this->rut_cliente_proveedor = $cliente_proveedor->get_rut();
				$this->nombre_cliente_proveedor = $cliente_proveedor->get_nombre();
			}
			else
			{
				$clog_Cliente_particular = new Controlador_Logico_Cliente_particular();
				$cliente_particular = $clog_Cliente_particular->getCliente_particular($this->id_cliente_proveedor); 
				if ($cliente_particular)
				{

					$this->rut_cliente_proveedor = $cliente_particular->get_rut();
					$this->nombre_cliente_proveedor = $cliente_particular->get_nombre() . " " . $cliente_particular->get_apellido_paterno() . " " . $cliente_particular->get_apellido_materno();
				}

			}
			
			$this->fecha_abono_cal = convertirFechaBD_fecha($this->fecha_abono);
			$tipo_comprobante = Tipos_comprobantes_getTipos_comprobantes($this->tipo);
			if ($tipo_comprobante)
				$this->nombre_tipo = $tipo_comprobante->descripcion;

		}
	}

	//------------------------------------------------------------------------------
	//	FUNCIONES GET PARA OBTENER ATRIBUTOS
	//------------------------------------------------------------------------------
	public function get_estado_img(){
		switch($this->estado){
			case "0": return ("nulo.gif");break;
			default: return ("celeste.gif");break;
		}
	}

	public function get_estado_nombre(){
		switch($this->estado){
			case "0": return ("Anulado");break;
			default: return ("OK");break;
		}
	}

	public function get_rut_cliente_proveedor(){
		return $this->rut_cliente_proveedor;
	}
	
	public function get_nombre_cliente_proveedor(){
		return $this->nombre_cliente_proveedor;
	}
	
	
	public function get_id_comprobante_pago(){
		return ($this->id_comprobante_pago);
	}

	public function get_id_cliente_proveedor(){
		return ($this->id_cliente_proveedor);
	}

	public function get_id_documento(){
		return ($this->id_documento);
	}

	public function get_tipo(){
		return ($this->tipo);
	}

	public function get_forma_pago(){
		return ($this->forma_pago);
	}

	public function get_abono(){
		return ($this->abono);
	}

	public function get_glosa(){
		return ($this->glosa);
	}
	
	public function get_fecha_abono_calendario(){
		return ($this->fecha_abono_cal);
	}
	
	public function get_fecha_abono(){
		return ($this->fecha_abono);
	}

	public function get_fecha_digitacion(){
		return ($this->fecha_digitacion);
	}

	public function get_numero_cheque(){
		return ($this->numero_cheque);
	}

	public function get_fecha_cheque(){
		return ($this->fecha_cheque);
	}

	public function get_estado(){
		return ($this->estado);
	}

	public function get_id_comprobante_contable(){
		return ($this->id_comprobante_contable);
	}

	public function get_id_empresa_seleccionada(){
		return ($this->id_empresa_seleccionada);
	}

	public function get_id_sucursal(){
		return ($this->id_sucursal);
	}

	public function get_numero_recibo(){
		return ($this->numero_recibo);
	}

	public function get_nombre_tipo(){
		return ($this->nombre_tipo);
	}


	//------------------------------------------------------------------------------
	//	FUNCIONES SET PARA SETEAR ATRIBUTOS
	//------------------------------------------------------------------------------

	public function set_id_comprobante_pago($id_comprobante_pago){
		$this->id_comprobante_pago = $id_comprobante_pago;
	}

	public function set_id_cliente_proveedor($id_cliente_proveedor){
		$this->id_cliente_proveedor = $id_cliente_proveedor;
	}

	public function set_id_documento($id_documento){
		$this->id_documento = $id_documento;
	}

	public function set_tipo($tipo){
		$this->tipo = $tipo;
	}

	public function set_forma_pago($forma_pago){
		$this->forma_pago = $forma_pago;
	}

	public function set_abono($abono){
		$this->abono = $abono;
	}

	public function set_glosa($glosa){
		$this->glosa = $glosa;
	}

	public function set_fecha_abono($fecha_abono){
		$this->fecha_abono = $fecha_abono;
	}

	public function set_fecha_digitacion($fecha_digitacion){
		$this->fecha_digitacion = $fecha_digitacion;
	}

	public function set_numero_cheque($numero_cheque){
		$this->numero_cheque = $numero_cheque;
	}

	public function set_fecha_cheque($fecha_cheque){
		$this->fecha_cheque = $fecha_cheque;
	}

	public function set_estado($estado){
		$this->estado = $estado;
	}

	public function set_id_comprobante_contable($id_comprobante_contable){
		$this->id_comprobante_contable = $id_comprobante_contable;
	}

	public function set_id_empresa_seleccionada($id_empresa_seleccionada){
		$this->id_empresa_seleccionada = $id_empresa_seleccionada;
	}

	public function set_id_sucursal($id_sucursal){
		$this->id_sucursal = $id_sucursal;
	}

	public function set_numero_recibo($numero_recibo){
		$this->numero_recibo = $numero_recibo;
	}



}
//------------------------------------------------------------------------------
//	FIN CLASE
//------------------------------------------------------------------------------

?>
