<?

//------------------------------------------------------------------------------
//	CLASE LOGICA
//------------------------------------------------------------------------------

class Libro_compra{
	//ES UN CONTENEDOR DE ATRIBUTOS SETEADOS EN TIEMPO DE EJECUCION

	private $id_documento;
	private $tipo_documento;
	private $id_proveedor;
	private $nombre_proveedor;
	private $rut_proveedor;
	private $numero_documento;
	private $correlativo;
	private $folio;
	private $fecha_documento;
	private $total_impuesto;
	private $total_exento;
	private $total_neto;
	private $total_iva;
	private $total_bruto;
	
	private $nombre_tipo_documento;
	private $nombre_tipo_documento_corto;
	
	private $fecha_documento_no_bd;
	
	private $estado;
	//CONSTRUCTOR
	public function __construct ($Libro_compra_BD)
	{
		if ($Libro_compra_BD){
			$this->id_documento = $Libro_compra_BD->get_id_documento();
			$this->tipo_documento = $Libro_compra_BD->get_tipo_documento();
			$this->id_proveedor = $Libro_compra_BD->get_id_proveedor();
			$this->nombre_proveedor = $Libro_compra_BD->get_nombre_proveedor();
			$this->rut_proveedor = $Libro_compra_BD->get_rut_proveedor();
			$this->numero_documento = $Libro_compra_BD->get_numero_documento();
			$this->correlativo = $Libro_compra_BD->get_correlativo();
			$this->folio = $Libro_compra_BD->get_folio();
			$this->fecha_documento = $Libro_compra_BD->get_fecha_documento();
			
			$this->total_exento = $Libro_compra_BD->get_total_exento();
			$this->total_neto = $Libro_compra_BD->get_total_neto();
			$this->total_iva = $Libro_compra_BD->get_total_iva();
			$this->total_bruto = $Libro_compra_BD->get_total_bruto();
			
			switch ($this->tipo_documento){
				case "0": $this->nombre_tipo_documento_corto = "B";$this->nombre_tipo_documento = "Boleta"; break;
				case "1": $this->nombre_tipo_documento_corto = "F";$this->nombre_tipo_documento = "Factura"; break;
				case "2": $this->nombre_tipo_documento_corto = "NC";$this->nombre_tipo_documento = "Nota de Crdito"; break;
				case "3": $this->nombre_tipo_documento_corto = "ND";$this->nombre_tipo_documento = "Nota de Dbito"; break;
			}
			
			$this->fecha_documento_no_bd = convertirFechaBD_fecha($this->fecha_documento);
			
			$documento_original = Documento_compra_getDocumento_compra($this->id_documento);
			if ($documento_original){
				$this->estado = $documento_original->get_estado();
				$this->total_impuesto = $documento_original->get_total_impuesto();
			}			
		}
	}

	//------------------------------------------------------------------------------
	//	FUNCIONES GET PARA OBTENER ATRIBUTOS
	//------------------------------------------------------------------------------
	public function get_total_impuesto(){
		return ($this->total_impuesto);
	}	
	
	public function get_fecha_documento_no_bd(){
		return ($this->fecha_documento_no_bd);
	}
	
	public function get_nombre_tipo_documento(){
		return ($this->nombre_tipo_documento);
	}
	
	public function get_nombre_tipo_documento_corto(){
		return ($this->nombre_tipo_documento_corto);
	}
	
	public function get_id_documento(){
		return ($this->id_documento);
	}

	public function get_tipo_documento(){
		return ($this->tipo_documento);
	}

	public function get_id_proveedor(){
		return ($this->id_proveedor);
	}

	public function get_nombre_proveedor(){
		return ($this->nombre_proveedor);
	}

	public function get_rut_proveedor(){
		return ($this->rut_proveedor);
	}

	public function get_numero_documento(){
		return ($this->numero_documento);
	}

	public function get_correlativo(){
		return ($this->correlativo);
	}

	public function get_folio(){
		return ($this->folio);
	}

	public function get_fecha_documento(){
		return ($this->fecha_documento);
	}

	public function get_total_exento(){
		return ($this->total_exento);
	}

	public function get_total_neto(){
		return ($this->total_neto);
	}

	public function get_total_iva(){
		return ($this->total_iva);
	}

	public function get_total_bruto(){
		return ($this->total_bruto);
	}

	public function get_estado(){
		return ($this->estado);
	}

	//------------------------------------------------------------------------------
	//	FUNCIONES SET PARA SETEAR ATRIBUTOS
	//------------------------------------------------------------------------------

	public function set_id_documento($id_documento){
		$this->id_documento = $id_documento;
	}

	public function set_tipo_documento($tipo_documento){
		$this->tipo_documento = $tipo_documento;
	}

	public function set_id_proveedor($id_proveedor){
		$this->id_proveedor = $id_proveedor;
	}

	public function set_nombre_proveedor($nombre_proveedor){
		$this->nombre_proveedor = $nombre_proveedor;
	}

	public function set_rut_proveedor($rut_proveedor){
		$this->rut_proveedor = $rut_proveedor;
	}

	public function set_numero_documento($numero_documento){
		$this->numero_documento = $numero_documento;
	}

	public function set_correlativo($correlativo){
		$this->correlativo = $correlativo;
	}

	public function set_folio($folio){
		$this->folio = $folio;
	}

	public function set_fecha_documento($fecha_documento){
		$this->fecha_documento = $fecha_documento;
	}

	public function set_total_exento($total_exento){
		$this->total_exento = $total_exento;
	}

	public function set_total_neto($total_neto){
		$this->total_neto = $total_neto;
	}

	public function set_total_iva($total_iva){
		$this->total_iva = $total_iva;
	}

	public function set_total_bruto($total_bruto){
		$this->total_bruto = $total_bruto;
	}



}
//------------------------------------------------------------------------------
//	FIN CLASE
//------------------------------------------------------------------------------

?>
