<?

//------------------------------------------------------------------------------
	//	CLASE
//------------------------------------------------------------------------------

class Usuario{
	//ES UN CONTENEDOR DE ATRIBUTOS SETEADOS EN TIEMPO DE EJECUCION
	
	var $id_usuario;
	var $id_sucursal;
	var $nombre_sucursal;
	var $nombre;
	var $apellido;
	var $email;
	var $login;
	var $password;
	var $privilegio;
	var $id_bodega_ventas;
	var $nombre_bodega_ventas;
	var $nombre_bodega_cristales;
	var $es_contralor;
	var $tipo_usuario;
	var $id_cliente_proveedor;
	var $nombre_tipo_usuario;

	//CONSTRUCTOR
	/**
	* @return Usuario
	* @param $id_usuario;
	* @param $id_sucursal;
	* @param $nombre;
	* @param $apellido;
	* @param $email;
	* @param $login;
	* @param $password;
	* @param $privilegio;
	* @desc Constructor de la Clase
	*/
	
	function Usuario ($id_sucursal, $nombre, $apellido, $email, $login, $password, $privilegio, $tipo_usuario, $id_cliente_proveedor, $id_usuario=0)
	{
		$this->id_usuario = $id_usuario;
		$this->id_sucursal = $id_sucursal;
		$this->nombre = $nombre;
		$this->apellido = $apellido;
		$this->email = $email;
		$this->login = $login;
		$this->password = $password;
		$this->privilegio = $privilegio;
		$this->tipo_usuario = $tipo_usuario;
		$this->id_cliente_proveedor = $id_cliente_proveedor;

		
		if ($this->tipo_usuario == 1)
			$this->nombre_tipo_usuario = "Interno";
		
		if ($this->tipo_usuario == 2)
			$this->nombre_tipo_usuario = "Externo";


		if ($id_cliente_proveedor)
		{
			$clog_Cont_cliente_proveedor = new Controlador_Logico_Cont_cliente_proveedor();
			$cont_cliente_proveedor = $clog_Cont_cliente_proveedor->getCont_cliente_proveedor($id_cliente_proveedor); 
			if ($cont_cliente_proveedor)
				$this->nombre_empresa = $cont_cliente_proveedor->razon_social;
			else
				$this->nombre_empresa = "Indefinido";
		}
		else
		{
			$clog_Parametros = new Controlador_Logico_Parametros();
			$filtro_parametros["codigo"] = "EMPRESA";
			$listado_parametros = $clog_Parametros->getListadoParametros($filtro_parametros, $extra_parametros);
			if ($listado_parametros)
				$this->nombre_empresa = $listado_parametros[0]->value;
			else
				$this->nombre_empresa = "Indefinido";
		}
		
		$this->nombre_sucursal = "Todas las Sucursales";
		if ($this->id_sucursal){
			$sucursal = Sucursal_getSucursal($this->id_sucursal);
			if ($sucursal) {
				$this->nombre_sucursal = $sucursal->get_descripcion();
				$this->id_bodega_ventas = $sucursal->get_id_bodega_ventas();
				$this->nombre_bodega_ventas = $sucursal->get_nombre_bodega_ventas();
				$this->nombre_bodega_cristales = $sucursal->get_nombre_bodega_cristales();
			}else{
				$this->nombre_sucursal = "Todas las Sucursales";
			}	
		}
	
		if (substr($this->privilegio,112,1) == 1)
			$this->es_contralor = true;
		else
			$this->es_contralor = false;


		if (substr($this->privilegio,138,1) == 1)
			$this->ver_costos = true;
		else
			$this->ver_costos = false;

	}
	
//------------------------------------------------------------------------------
	//	FUNCIONES GET PARA OBTENER ATRIBUTOS
//------------------------------------------------------------------------------

/**
* @return id_usuario
* @desc Retorna la variable id_usuario
*/
	function get_nombre_completo()
	{
		return ($this->nombre_completo = $this->nombre. " ". $this->apellido);
	}

	function check_permisos($idx){
		if (substr($this->privilegio, $idx, 1)) return "checked";
		return "";
	}	

	function get_id_usuario(){
		return ($this->id_usuario);
	}
	
	function get_nombre_sucursal(){
		return ($this->nombre_sucursal);
	}
	
	function get_nombre_bodega_ventas(){
		return ($this->nombre_bodega_ventas);
	}
	
	function get_nombre_bodega_cristales(){
		return ($this->nombre_bodega_cristales);
	}
	
	/**
	* @return id_sucursal
	* @desc Retorna la variable id_sucursal
	*/
	
	function get_id_sucursal(){
		return ($this->id_sucursal);
	}
	
	/**
	* @return nombre
	* @desc Retorna la variable nombre
	*/
	
	function get_nombre(){
		return ($this->nombre);
	}
	
	/**
	* @return apellido
	* @desc Retorna la variable apellido
	*/
	
	function get_apellido(){
		return ($this->apellido);
	}
	
	/**
	* @return email
	* @desc Retorna la variable email
	*/
	
	function get_email(){
		return ($this->email);
	}
	
	/**
	* @return login
	* @desc Retorna la variable login
	*/
	
	function get_login(){
		return ($this->login);
	}
	
	/**
	* @return password
	* @desc Retorna la variable password
	*/
	
	function get_password(){
		return ($this->password);
	}
	
	/**
	* @return privilegio
	* @desc Retorna la variable privilegio
	*/
	
	function get_privilegio(){
		return ($this->privilegio);
	}
	
	function get_tipo_usuario(){
		return ($this->tipo_usuario);
	}

	function get_id_cliente_proveedor(){
		return ($this->id_cliente_proveedor);
	}


	
	
//------------------------------------------------------------------------------
	//	FUNCIONES SET PARA SETEAR ATRIBUTOS
//------------------------------------------------------------------------------

/**
* @return void
* @desc Setea la variable id_usuario
*/

	function set_id_usuario($id_usuario){
		$this->id_usuario = $id_usuario;
	}
	
	/**
	* @return void
	* @desc Setea la variable id_sucursal
	*/
	
	function set_id_sucursal($id_sucursal){
		$this->id_sucursal = $id_sucursal;
	}
	
	/**
	* @return void
	* @desc Setea la variable nombre
	*/
	
	function set_nombre($nombre){
		$this->nombre = $nombre;
	}
	
	/**
	* @return void
	* @desc Setea la variable apellido
	*/
	
	function set_apellido($apellido){
		$this->apellido = $apellido;
	}
	
	/**
	* @return void
	* @desc Setea la variable email
	*/
	
	function set_email($email){
		$this->email = $email;
	}
	
	/**
	* @return void
	* @desc Setea la variable login
	*/
	
	function set_login($login){
		$this->login = $login;
	}
	
	/**
	* @return void
	* @desc Setea la variable password
	*/
	
	function set_password($password){
		$this->password = $password;
	}
	
	/**
	* @return void
	* @desc Setea la variable privilegio
	*/
	
	function set_privilegio($privilegio){
		$this->privilegio = $privilegio;
	}
	
	function set_tipo_usuario($tipo_usuario){
		$this->tipo_usuario = $tipo_usuario;
	}

	function set_id_cliente_proveedor($id_cliente_proveedor){
		$this->id_cliente_proveedor = $id_cliente_proveedor;
	}

	
	
	}
//------------------------------------------------------------------------------
	//	FIN CLASE
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
	//	FUNCIONES AUXILIARES
//------------------------------------------------------------------------------

	function Usuario_getListadoUsuario($id=0){
		return Usuario_Fachada::getListadoUsuario($id);
	}
	
	function Usuario_getListadoUsuario_filtro($filtro,$extra){
		return Usuario_Fachada::getListadoUsuario_filtro($filtro,$extra);
	}

	function Usuario_getUsuario($id_usuario){
		return Usuario_Fachada::getUsuario($id_usuario);
	}
	
	function Usuario_guardarUsuario($objeto){
		return Usuario_Fachada::guardarUsuario($objeto);
	}
	
	function Usuario_actualizarUsuario($objeto){
		return Usuario_Fachada::actualizarUsuario($objeto);
	}
	
	function Usuario_eliminarUsuario($id_usuario){
		return Usuario_Fachada::eliminarUsuario($id_usuario);
	}
	
	function Usuario_isUsuario($login, $password){
		return Usuario_Fachada::isUsuario($login, $password);
	} 	
	
?>
