<?

//------------------------------------------------------------------------------
	//	FUNCIONES FACHADA
//------------------------------------------------------------------------------

class Atributo_Fachada {

/**
 * @return atributo[]  Retorna un listado de atributos
 * @param int $id  id de la subfamilia
 * @desc Retorna el listado de atributos correspondientes a una subfamilia especifica
*/
function &getListadoAtributo($id)
	{
		global $conn;
		
	if ($id == 0){
		$where = "";
	}else{
		$where = "WHERE id_subfamilia = '$id'";
	}
	
	$query = expandir("GET_LISTADO_ATRIBUTO",
	"where",	$where
	);
	
	$conn -> debug = CONN_DEBUG;
	$RecordSet = &$conn -> Execute($query);
	
	if ($RecordSet->_numOfRows == 0) {
		return false;
		exit;
	}
	
	$cont = 0;
	
	while (!$RecordSet -> EOF) {
		$id_atributo = $RecordSet -> Fields("id_atributo");
		$id_subfamilia = $RecordSet -> Fields("id_subfamilia");
		$nombre = $RecordSet -> Fields("nombre");
		$observacion = $RecordSet -> Fields("observacion");
		
		$temp = new Atributo ($id_subfamilia, $nombre, $observacion, $id_atributo);
		$vector[$cont++] = $temp;
		$RecordSet -> MoveNext();
	}
	
	return $vector;
	}
	
	
	/**
	* @return atributo
	* @param int $id_atributo 
	* @desc Retorna un ojeto atributo a partir de su id_atributo
	*/
	function &getAtributo($id_atributo)
	{
		global $conn;
		$query = expandir("GET_ATRIBUTO",
		"id_atributo", $id_atributo
		);
		
		$conn -> debug = CONN_DEBUG;
		$RecordSet = &$conn -> Execute($query);
		
	if ($RecordSet->_numOfRows == 0) {
		return false;
		exit;
	}
	
	$id_atributo = $RecordSet -> Fields("id_atributo");
	$id_subfamilia = $RecordSet -> Fields("id_subfamilia");
	$nombre = $RecordSet -> Fields("nombre");
	$observacion = $RecordSet -> Fields("observacion");
	
	
	$temp = new Atributo ($id_subfamilia, $nombre, $observacion, $id_atributo);
	return $temp;
	}
	
	
	/**
	* @return int retorna el id del atributo recien almacenado
	* @param atributo $objeto
	* @desc Guarda un nuevo atributo en la DB
	*/
	function &guardarAtributo($objeto){
		global $conn;
		$conn -> debug = CONN_DEBUG;
		
		$query = expandir("GUARDAR_ATRIBUTO",
		"nombre", $objeto->nombre,
		"observacion", $objeto->observacion,
		"id_subfamilia", $objeto->id_subfamilia);
		
		$RecordSet = &$conn -> Execute($query);
	if ($RecordSet->_numOfRows == 0) {
		return false;
		exit;
	}
	return $conn->Insert_Id();
	
	
	}
	
	/**
	* @return boolean
	* @param atributo $objeto Objeto de tipo "atributo" a actualizar
	* @desc Actualiza los campos del objeto atributo recibido por parametro
	*/
	function &actualizarAtributo($objeto){
		global $conn;
		$conn -> debug = CONN_DEBUG;
		
		$query = expandir("ACTUALIZAR_ATRIBUTO",
		"id_subfamilia", $objeto->id_subfamilia,
		"nombre", $objeto->nombre,
		"observacion", $objeto->observacion,
		"id_atributo", $objeto->id_atributo);
		
		$RecordSet = &$conn -> Execute($query);
	if ($RecordSet->_numOfRows == 0) {
		return false;
		exit;
	}
	return true;
	}
	
	/**
	* @return boolean
	* @param int $id_atributo id del atributo a eliminar
	* @desc Elimina un atributo de la tabla a partir del id
	*/
	function &eliminarAtributo($id_atributo){
		global $conn;
		$query = expandir("ELIMINAR_ATRIBUTO",
		"id_atributo", $id_atributo
		);
		$conn -> debug = CONN_DEBUG;
		$RecordSet = &$conn -> Execute($query);
		
	if ($RecordSet->_numOfRows == 0) {
		return false;
		exit;
	}
	return true;
	}
	
	
	}//Fin Clase
?>
