<?php

$opts = array(
'ssl' => array('verify_peer' => false, 'verify_peer_name' => false)
);

$ns = 'http://www.w3.org/2005/08/addressing';

$action = new \SoapHeader($ns, 'Action', 'VentaServicio/VentaServicio/Login', true);
$to = new \SoapHeader($ns, 'To', env('DEFONTANA_SERVICE_URL'), false);

$this->soapWrapper->add('Defontana', function ($service) use($action, $to, $opts) {
$service
->options([
'soap_version' => SOAP_1_2,
'location' => env('DEFONTANA_SERVICE_URL'),
'trace' => 1,
'exceptions' => 0,
'stream_context' => stream_context_create($opts)
])
->wsdl(env('DEFONTANA_SERVICE_URL'))
->customHeader($action)
->customHeader($to)
->trace(true)
->classmap([
Login::class,
LoginResponse::class,
]);
});

$response = $this->soapWrapper->call('Defontana.Login', 
[
new Login(
env('DEFONTANA_IDEMPRESA'), 
env('DEFONTANA_IDUSUARIO'), 
env('DEFONTANA_PASSWORD'), 
env('DEFONTANA_IDEQUIPO'))
]
);

$expiresAt = now()->addMinutes(30);

Cache::put('token', $response->LoginResult->Token, $expiresAt);
Cache::put('sesion', $response->LoginResult->IDSesion, $expiresAt);
Cache::put('cliente', $response->LoginResult->IDCliente, $expiresAt);